<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://d3js.org/d3.v4.min.js"></script>
    <script src="https://d3js.org/d3-geo.v1.min.js"></script>
    <script src="http://d3js.org/topojson.v1.min.js"></script>
    <script src="https://d3js.org/d3-ease.v1.min.js"></script>
    <script src="./d3-simple-slider.js"></script>
    <script src="https://d3js.org/d3-geo-projection.v2.min.js"></script>
    
    <link rel="stylesheet" href="style.css">
    <title>CO2 Emissions Visualization</title>
    <style>
        .chart rect {
            fill: steelblue;
        }

        .chart text {
            fill: white;
            font: 10px sans-serif;
            text-anchor: end;
        }

        .line {
            fill: none;
            stroke: steelblue;
            stroke-width: 2px;
        }

        .axis-label {
            font-size: 12px;
            font-weight: bold;
        }
    </style>
</head>
<body>
    
    <h1 class="white center padding">CO2 Emissions (kt) per capita in year: <span id="value1"></span></h1>
    <p id="value1"></p>
    <div class="container">
        <div id="mapContainer" class="container-item"></div>
        <div class="sideContainer">
            <div class="viewToggle">
                <button id="showCountryInfo">Show Country Info</button>
                <button id="showLineGraph">Show Line Graph</button>
            </div>
            <svg id="barChart"></svg>
            <div id="selectedCountryInfo"></div>
            <svg id="lineChart"></svg>
        </div>
    </div>

    <select class="margin" id="countries" style="margin:20px">
        <option selected>Choose country...</option>
    </select>
    
    <div id="slider"></div>


    <script type="module">
        var val;
        const width = window.innerWidth-100;
        const height = 800;
        let countries, jsonData;

        // Map and countries setup
        const svg = d3.select("#mapContainer").append("svg")
            .attr("id", "mapSvg")
            .attr("width", width)
            .attr("height", height * 0.95);

        const projection = d3.geoNaturalEarth1()
            .scale(230)
            .translate([width / 2.25, height / 2.15]);

        const pathGenerator = d3.geoPath().projection(projection);
        
        const mapGroup = svg.append('g');

        mapGroup.append('path')
            .attr('class', 'sphere')
            .attr('d', pathGenerator({type: "Sphere"}));

        mapGroup.append('path')
            .datum({type: 'Sphere'})
            .attr('class', 'sea')
            .attr('d', pathGenerator)
            .style('fill', 'lightblue');

        const zoom = d3.zoom()
            .scaleExtent([1, 5])
            .on('zoom', () => {
                mapGroup.attr('transform', d3.event.transform);
            });

        svg.call(zoom);

        let selectedYear = 1990;
        d3.json("countries-110m.json", function(error, topoJSONdata) {
            if (error) throw error;
            countries = topojson.feature(topoJSONdata, topoJSONdata.objects.countries);

            d3.json("data.json", function(error, data) {
                if (error) throw error;
                jsonData = data;

                countries.features.forEach(d => {
                    const countryData = jsonData.filter(item => item.field[0] === d.properties.name);
                    if (countryData) {
                        countryData.forEach(entry => {
                            const year = entry.field[2];
                            const value = entry.field[3];
                            d.properties[year] = parseFloat(value.toFixed(4));
                        });
                    }
                });

                const countryNames = countries.features.map(item => item.properties.name).filter(Boolean);
                countryNames.sort();

                const dropDown = d3.select("#countries");
                dropDown.selectAll(null)
                    .data(countryNames)
                    .enter()
                    .append("option")
                    .attr("value", function (d) { return d; })
                    .text(function (d) { return d; });

                updateMap(1990); // Initial map render
                console.log("executed")
            });

            function updateMap(year) {
                const colorScale = d3.scaleLinear()
                    .domain([0, d3.max(countries.features, d => d.properties[year]) || 0])
                    .range(["lightyellow", "darkred"]);

                const countryPaths = mapGroup.selectAll('path.country')
                    .data(countries.features);

                countryPaths.enter().append('path')
                    .attr('class', 'country')
                    .attr('d', pathGenerator)
                    .append("title") // Add title element for tooltip
                    .text(d => {
                        const countryName = d.properties.name;
                        const emissions = d.properties[year] || 'No data';
                        return `Country: ${countryName}\nYear: ${year}\nCO2 Emissions (${year}): ${emissions}`;
                    });

                countryPaths
                    .attr('fill', d => d.properties[year] ? colorScale(d.properties[year]) : 'lightgray');

                // Update title elements for existing country paths
                countryPaths.select('title')
                    .text(d => {
                        const countryName = d.properties.name;
                        const emissions = d.properties[year] || 'No data';
                        return `Country: ${countryName}\nYear: ${year}\nCO2 Emissions (${year}): ${emissions}`;
                    });

                countryPaths.exit().remove();

                const selectedCountryDiv = d3.select("#selectedCountryInfo");
                selectedCountryDiv.html("");

                const select = document.getElementById('countries');
                const selectedCountryName = select.options[select.selectedIndex].value;
                const selectedCountry = countries.features.find(item => item.properties.name === selectedCountryName);

                if (selectedCountry) {
                    const emissions = selectedCountry.properties[year] || 'No data';
                    selectedCountryDiv.html(`
                        <h3>Selected Country Info</h3>
                        <p>Country: ${selectedCountryName}</p>
                        <p>Year: ${year}</p>
                        <p>CO2 Emissions (${year}): ${emissions}</p>
                    `);
                    d3.select("#lineChart").selectAll("*").remove();
                    updateLineChart(selectedCountry);
                    
                }

                var topCountries = getTopCountries(jsonData, year);
                d3.select("#barChart").selectAll("*").remove();
                createBarChart(topCountries, year);
                
                mapGroup.selectAll('.country-border')
                    .data(topojson.feature(topoJSONdata, topoJSONdata.objects.countries).features)
                    .enter()
                    .append('path')
                    .attr('class', 'country-border')
                    .attr('d', pathGenerator)
                    .style('fill', 'none')
                    .style('stroke', 'white')
                    .style('stroke-width', '0.5px');

                dropDown.on('change', function() {
                    const select = document.getElementById('countries');
                    const name = select.options[select.selectedIndex].value;
                    const country = countries.features.find(item => item.properties.name === name);
                    if (country) {
                        updateLineChart(country);
                        d3.select("#lineChart").selectAll("*").remove();
                    }
                });
            }            

            var sliderWidth = 1200; 
            var sliderHeight = 70; 

            var slider = d3
                .sliderHorizontal()
                .min(1990)
                .max(2020)
                .step(1)
                .width(sliderWidth)
                .height(50)
                .displayValue(false)
                .tickFormat(d3.format("d"))
                .on('onchange', function(value) {
                    val = value; 
                    d3.select('#value1').text(val); 
                    updateMap(val);
                });

            var sliderSvg = d3.select('#slider')
                .append('svg')
                .attr('width', sliderWidth)
                .attr('height', sliderHeight)
                .append('g')
                .attr('transform', 'translate(30,30)')
                .call(slider);//ok

        });

        let graphSvg = d3.select("body").select("svg");
        if (graphSvg.empty()) {
            graphSvg = d3.select("body").append("svg")
                .attr("width", width)
                .attr("height", height * 0.75);
}
        
        function numberWithSpaces(x) {
            return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
        }
    
        function createBarChart(topCountries, year) {
            var margin = {top: 50, right: 20, bottom: 50, left: 40},
                width = 400 - margin.left - margin.right,
                height = 300 - margin.top - margin.bottom;

            var svg = d3.select("#barChart")
                .attr("width", width + margin.left + margin.right)
                .attr("height", height + margin.top + margin.bottom)
                .append("g")
                .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

            var x = d3.scaleBand()
                .range([0, width])
                .padding(0.1);

            var y = d3.scaleLinear()
                .range([height, 0]);

            x.domain(topCountries.map(function(d) { return d.field[0]; }));
            y.domain([0, d3.max(topCountries, function(d) { return d.field[3]; })]);

            svg.selectAll(".bar")
                .data(topCountries)
                .enter().append("rect")
                .attr("class", "bar")
                .attr("x", function(d) { return x(d.field[0]); })
                .attr("width", x.bandwidth())
                .attr("y", function(d) { return y(d.field[3]); })
                .attr("height", function(d) { return height - y(d.field[3]); });

            svg.append("g")
                .attr("transform", "translate(0," + height + ")")
                .call(d3.axisBottom(x))
                .selectAll(".tick text")
                .call(wrap, x.bandwidth());

            svg.append("g")
                .call(d3.axisLeft(y));

            svg.append("text")
                .attr("x", (width / 2))
                .attr("y", -margin.top / 2)
                .attr("text-anchor", "middle")
                .style("font-size", "16px")
                .text("Top Countries with Highest CO2 Emissions in " + year);
        }

        function wrap(text, width) {
            text.each(function() {
                var text = d3.select(this),
                    words = text.text().split(/\s+/).reverse(),
                    word,
                    line = [],
                    lineNumber = 0,
                    lineHeight = 1.1,
                    y = text.attr("y"),
                    dy = parseFloat(text.attr("dy")) || 0,
                    tspan = text.text(null).append("tspan").attr("x", 0).attr("y", y).attr("dy", dy + "em");
                while (word = words.pop()) {
                    line.push(word);
                    tspan.text(line.join(" "));
                    if (tspan.node().getComputedTextLength() > width) {
                        line.pop();
                        tspan.text(line.join(" "));
                        line = [word];
                        tspan = text.append("tspan").attr("x", 0).attr("y", y).attr("dy", ++lineNumber * lineHeight + dy + "em").text(word);
                    }
                }
            });
        }

        function getTopCountries(data, year) {
            const dataForYear = data.filter(entry => entry.field[2] === year);
            dataForYear.sort((a, b) => b.field[3] - a.field[3]);
            return dataForYear.slice(0, 3);
        }

        function updateLineChart(country) {
            const countryName = country.properties.name;
            const emissionsData = [];

            for (let year = 1990; year <= 2020; year++) {
                if (country.properties[year]) {
                    emissionsData.push({
                        year: year,
                        emissions: country.properties[year]
                    });
                }
            }

            const margin = {top: 50, right: 20, bottom: 40, left: 50};
            const lineChartWidth = 400 - margin.left - margin.right;
            const lineChartHeight = 300 - margin.top - margin.bottom;

            const svg = d3.select("#lineChart")
                .attr("width", lineChartWidth + margin.left + margin.right)
                .attr("height", lineChartHeight + margin.top + margin.bottom)
                .append("g")
                .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

            const x = d3.scaleLinear()
                .domain(d3.extent(emissionsData, d => d.year))
                .range([0, lineChartWidth]);

            const y = d3.scaleLinear()
                .domain([0, d3.max(emissionsData, d => d.emissions)])
                .range([lineChartHeight, 0]);

            const line = d3.line()
                .x(d => x(d.year))
                .y(d => y(d.emissions));

            svg.append("g")
                .attr("transform", "translate(0," + lineChartHeight + ")")
                .call(d3.axisBottom(x).tickFormat(d3.format("d")))
                .selectAll("text")  
                .style("text-anchor", "end")
                .attr("dx", "-.8em")
                .attr("dy", ".15em")
                .attr("transform", "rotate(-65)");;
                
                

            svg.append("g")
                .call(d3.axisLeft(y));

            svg.append("path")
                .datum(emissionsData)
                .attr("class", "line")
                .attr("d", line);

            svg.append("text")
                .attr("x", (lineChartWidth / 2))
                .attr("y", -margin.top / 2)
                .attr("text-anchor", "middle")
                .style("font-size", "16px")
                .text("CO2 Emissions for " + countryName + " (1990-2020)");

            svg.append("text")
                .attr("transform", "rotate(-90)")
                .attr("y", 0 - margin.left)
                .attr("x", 0 - (lineChartHeight / 2))
                .attr("dy", "1em")
                .attr("class", "axis-label")
                .text("CO2 Emissions");

            svg.append("text")
                .attr("x", lineChartWidth / 2)
                .attr("y", lineChartHeight + margin.bottom)
                .attr("dy", "-3em")
                .attr("class", "axis-label")
                .text("Year");
        }

        document.getElementById('showCountryInfo').addEventListener('click', () => {
            document.getElementById('selectedCountryInfo').style.display = 'block';
            document.getElementById('barChart').style.display = 'block';
            document.getElementById('lineChart').style.display = 'none';
        });

        document.getElementById('showLineGraph').addEventListener('click', () => {
            document.getElementById('selectedCountryInfo').style.display = 'none';
            document.getElementById('barChart').style.display = 'block';
            document.getElementById('lineChart').style.display = 'block';
        });
    </script>  
</body>

</html>
